Scriptname aDivineInterventionScript extends ActiveMagicEffect  

GlobalVariable Property aAllowDivineIntervention  Auto  
ObjectReference Property aMarkarthDivineMarker  Auto  
ObjectReference Property aMarkarthPosMarker  Auto  
ObjectReference Property aRiftenDivineMarker  Auto  
ObjectReference Property aRiftenPosMarker  Auto  
ObjectReference Property aSolitudeDivineMarker  Auto  
ObjectReference Property aSolitudePosMarker  Auto  
ObjectReference Property aWhiterunDivineMarker  Auto  
ObjectReference Property aWhiterunPosMarker  Auto  
ObjectReference Property aWindhelmDivineMarker  Auto  
ObjectReference Property aWindhelmPosMarker  Auto  
ImageSpaceModifier Property MAGAlduinFinalExplosionImod  Auto  
Sound Property aDivineInterventionSound  Auto  

float FUNCTION min(float x, float y)
	IF x <= y
		return x
	ELSE
		return y
	endIF
endFUNCTION

EVENT OnEffectStart(Actor akTarget, Actor akCaster)
	IF akCaster.IsInInterior() == 1 && aAllowDivineIntervention.GetValue() == 0
		Debug.Notification("Objects block your path to Aetherius. Go outside.")
	ELSE

		float markarth = akCaster.GetDistance(aMarkarthPosMarker)
		float riften = akCaster.GetDistance(aRiftenPosMarker)
		float solitude = akCaster.GetDistance(aSolitudePosMarker)
		float whiterun = akCaster.GetDistance(aWhiterunPosMarker)
		float windhelm = akCaster.GetDistance(aWindhelmPosMarker)

		float mindist = min(min(min(min(markarth, riften), solitude), whiterun), windhelm)

		;Debug.MessageBox("markarth: " + markarth + "\nriften: " + riften + "\nsolitude: " + solitude + "\nwhiterun: " + whiterun + "\nwindhelm: " + windhelm + "\nmindist: " + mindist)

		IF mindist == markarth
			akCaster.MoveTo(aMarkarthDivineMarker)
		elseIF mindist == riften
			akCaster.MoveTo(aRiftenDivineMarker)
		elseIF mindist == solitude
			akCaster.MoveTo(aSolitudeDivineMarker)
		elseIF mindist == whiterun
			akCaster.MoveTo(aWhiterunDivineMarker)
		ELSE
			akCaster.MoveTo(aWindhelmDivineMarker)
		endIF

		MAGAlduinFinalExplosionImod.Apply(0.9)
		aDivineInterventionSound.Play(akCaster)
	endIF

endEVENT